

$EJECT
;=======================================================================
;
;     INCLUDE FILE DES MODULS HCANAPIF.A51
;
;=======================================================================



;*---------------------------------------------------------------------*
;*     C A N _ T A S K _ C R E A T E
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Starten des CAN-Task. Als erste Operation muss immer diese
;*     Funktion ausgefhrt werden, alle weiteren CAN-Operationen
;*     drfen nur nach dem Aufruf dieser Operation ausgefhrt werden.
;*
;* VAR
;*    I : BYTE;
;*
;* BEGIN
;*    C_DRIVER_IN_USE := FALSE;
;*    FOR I:=0 TO 2 DO
;*       C_TEMP_ORDER_BUF[I].OCCUPIED := FALSE;
;*    END FOR;
;*    CAN-Task starten;
;*    IF Task-gestartet THEN
;*       RETURN C_OK;
;*    ELSE
;*       RETURN C_NOT_STARTED;
;*    END;
;* END CAN_TASK_CREATE;
;*
;*---------------------------------------------------------------------*
;*  Parameter:
;*
;*     --
;*
;*  Returnwert im AKKU :
;*
;*        C_OK          :   CAN-Task gestartet
;*        C_NOT_STARTED :   CAN-Task konnte nicht gestartet werden
;*
;*---------------------------------------------------------------------*/

?CAN?can_task_create?HCANAPIF     SEGMENT CODE
                                 RSEG    ?CAN?can_task_create?HCANAPIF

can_task_create:
                        ; Globale Variablen Initialisieren
                        CLR     C_DRIVER_IN_USE
                        MOV     A,#FALSE
                        MOV     DPTR,#C_TEMP_BUF_0_OCC
                        MOVX    @DPTR,A
                        MOV     DPTR,#C_TEMP_BUF_1_OCC
                        MOVX    @DPTR,A
                        MOV     DPTR,#C_TEMP_BUF_2_OCC
                        MOVX    @DPTR,A

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_create_task
                        ; Rckgabewert auswerten
                        MOV     A, R7
                        JNZ     CTS_1
                        ; Task gestartet
                        MOV     R7, #C_OK
                        RET
CTS_1:                  ; Task konnte nicht gestartet werden
                        MOV     R7, #C_NOT_STARTED
                        RET

$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ H W _ I N I T
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Grundlegende HW-Initialisierung des CAN-Controllers, Lschen
;*     aller Kommunikationsobjekte. Nach einem CAN_HW_INIT ist der
;*     CAN-Treiber bereit zu einer kompletten Neudefinition aller
;*     Kommunikationsobjekte.
;*
;* BEGIN
;*
;*    R3 := BIT_LENGTH_1_REG;
;*    R4 := BIT_LENGTH_2_REG;
;*    R5 := OUTPUT_CONTROL_REG;
;*    R6 := SLEEP_AND_BR_PRESCALE;
;*    R7 := CLOCK_CONTROL_REG;
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_HW_INIT_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R3;
;*       C_ORDER_BUF.PARAM[1] := R4;
;*       C_ORDER_BUF.PARAM[2] := R5;
;*       C_ORDER_BUF.PARAM[3] := R6;
;*       C_ORDER_BUF.PARAM[4] := R7;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_HW_INIT;
;*
;*---------------------------------------------------------------------*
;*  Parameter (abgespeichert ab ?_can_hw_init?BYTE) :
;*
;*     1. Byte : BIT_LENGTH_1_REG        Bit-Timing Register 0 des CAN-Controllers
;*     2. Byte : BIT_LENGTH_1_REG        Bit-Timing Register 1 des CAN-Controllers
;*     3. Byte : OUTPUT_CONTROL_REG      Konfiguration der Ausgangstreiber des CAN-
;*                                       Controllers
;*     4. Byte : SLEEP_AND_BR_PRESCAL 
;*     5. Byte : CLOCK_CONTROL_REG             
;*
;*
;*  Returnwert in R7 :
;*
;*        C_OK                Funktion ausgefhrt
;*        C_CONF_ERROR        Unmgliches Bus-Timing oder OUT_CONTROL Wert
;*        C_CAN_FAILURE       Probleme mit dem CAN-Controller
;*                            (falsche Adresse usw.)
;*
;*---------------------------------------------------------------------*/

;* Bereich fr die Parameter-Uebergabe (mehr als 3 Parameter)
?XD?_can_hw_init?HCANAPIF        SEGMENT XDATA
                                RSEG ?XD?_can_hw_init?HCANAPIF
?_can_hw_init?BYTE:
bit_length_1:           DS 1
bit_length_2:           DS 1
output_control:         DS 1
sleep_and_br_presc:     DS 1
clock_control:          DS 1


?CAN?_can_hw_init?HCANAPIF     SEGMENT CODE
                              RSEG    ?CAN?_can_hw_init?HCANAPIF

_can_hw_init:
                        ; Parameter in die Register holen
                        ; die ersten 3 Parameter sind bereits in den Regs.
                        MOV     A, R5
                        MOV     R4, A               ; speichere bit_length_1

                        MOV     A, R3
                        MOV     R5, A               ; speichere output-control

                        MOV     A, R7
                        MOV     R3, A               ; speichere bit_length_2

                        MOV     DPTR, #sleep_and_br_presc
                        MOVX    A, @DPTR
                        MOV     R6, A

                        INC     DPTR				; speichere clock_control
                        MOVX    A, @DPTR
                        MOV     R7, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CHI_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_HW_INIT_ORDER, 5

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CHI_1:                  MOV     R7, #C_CAN_FAILURE
                        RET



$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ D E F _ O B J
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Definieren eines neuen Kommunikationsobjekts. Diese Funktion
;*     kann nur nach CAN_HW_INIT oder nach CAN_STOP ausgefhrt werden.
;*     Es knnen Objekte definiert werden, bis der Objekt-Speicher voll
;*     ist (beim Full-CAN ist dies das Controller-interne Dual-Port RAM,
;*     beim Basic-CAN wird der Objekt-Speicher im externen RAM alloziert)
;*     oder die maximale Anzahl von 255 definierten Objekten erreicht ist.
;*     Falls ein Objekt definiert wird, dass bereits existiert, wird eine
;*     Fehlermeldung (in CANRETURN) zurckgegeben.
;*     Nach der Beendigung der Initialisierung kann der CAN-Treiber mit
;*     CAN_START gestartet werden.
;*
;* BEGIN
;*    R3 := HIGH(IDENTIFIER);
;*    R4 := LOW(IDENTIFIER);
;*    R5 := DATA_LENGTH;
;*    R6 := OBJECT_TYP;
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_DEF_OBJ_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R3;
;*       C_ORDER_BUF.PARAM[1] := R4;
;*       C_ORDER_BUF.PARAM[2] := R5;
;*       C_ORDER_BUF.PARAM[3] := R6;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_HW_INIT;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*    R6/R7   : IDENTIFIER       Identifikation des Kommunikationsobjektes
;*                               entsprechend der CAN-Definition (0 .. 7EFH)
;*    R5      : DATA_LENGTH      Anzahl Datenbyte im Objekt (0..8)
;*    R3      : OBJECT_TYP       Genauere Beschreibung der Verwendungsart
;*                               des Objektes
;*
;*
;*  Returnwert in R7 :
;*
;*        C_OK                Objekt definiert
;*        C_NOT_STOPPED       CAN_STOP oder CAN_HW_INIT muss vor der
;*                            Ausfhrung dieser Funktion aufgerufen werden
;*        C_OBJ_ERROR         Objekt existiert schon
;*        C_TOO_LONG          DATA_LENGTH ist grsser als 8
;*        C_INVALID_TYPE      Falscher Objekttyp
;*        C_MEM_FULL          Objekt-Speicher ist voll, es knnen keine
;*                            neuen Objekte definiert werden
;*                            (zuerst alle Objekte mit CAN_HW_INIT lschen).
;*                            Entweder sind bereits 255 Objekte definiert
;*                            oder der Objekt-Speicher ist voll.
;*
;*---------------------------------------------------------------------*/


?CAN?_can_def_obj?HCANAPIF     SEGMENT CODE
                              RSEG    ?CAN?_can_def_obj?HCANAPIF
_can_def_obj:
                        XCHR    R6, R3
                        MOV     A, R7
                        MOV     R4, A
                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CDO_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_DEF_OBJ_ORDER, 4

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CDO_1:                  MOV     R7, #C_CAN_FAILURE
                        RET






$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ G E T _ S T A T U S
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Lesen des aktuellen CAN-Controller Status.
;*
;* BEGIN
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_GET_STATUS_ORDER;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,FFH,0);
;*       C_LEAVE_DRIVER;
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_STOP;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     --
;*
;*  Returnwert in R7 :
;*
;*        C_ERR_ACTIVE         Normale Operation
;*        C_ERR_PASSIVE        Error-passive mode erreicht
;*        C_BUS_OFF            CAN-Controller ist Bus-Off
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/

?CAN?can_get_status?HCANAPIF   SEGMENT CODE
                              RSEG    ?CAN?can_get_status?HCANAPIF

can_get_status:
                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CGS_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_GET_STATUS_ORDER, 0
                        ; Der Rest des Codes ist fr CAN_START, CAN_STOP
                        ; und CAN_GET_STATUS gemeinsam
                        JMP   COMMON_START_STOP_STATUS

CGS_1:                  MOV     R7, #C_CAN_FAILURE
                        RET





$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ S T O P
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Anhalten des CAN-Treibers zur Neudefinition von Objekten
;*     (mit CAN_DEF_OBJ) oder zum temporren Unterbrechen der
;*     Kommunikation. Im Unterschied zu CAN_HW_INIT werden bein Aufruf
;*     von CAN_STOP keine schon bestehenden Kommunikationsobjekte
;*     gelscht.
;*
;* BEGIN
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_STOP_ORDER;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,FFH,0);
;*       C_LEAVE_DRIVER;
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_STOP;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     --
;*
;*  Returnwert in R7 :
;*
;*        C_OK                 Treiber gestoppt
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/

?CAN?can_stop?HCANAPIF   SEGMENT CODE
                        RSEG    ?CAN?can_stop?HCANAPIF

can_stop:
                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CSP_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_STOP_ORDER, 0
                        ; Der Rest des Codes ist fr CAN_START, CAN_STOP
                        ; und CAN_GET_STATUS gemeinsam
                        JMP   COMMON_START_STOP_STATUS

CSP_1:                  MOV     R7, #C_CAN_FAILURE
                        RET



$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ S T A R T
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Starten des CAN-Treibers nach CAN_STOP oder nach CAN_DEF_OBJ
;*     (CAN_DEF_OBJ kann nur nach CAN_STOP oder CAN_HW_INIT ausgefhrt
;*     werden).
;*
;* BEGIN
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_STOP_ORDER;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_START;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     --
;*
;*     Returnwert in R7:
;*
;*        C_OK                 Treiber gestoppt
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/

?CAN?can_start?HCANAPIF   SEGMENT CODE
                         RSEG    ?CAN?can_start?HCANAPIF

can_start:
                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CST_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_START_ORDER, 0


                        ; Der Rest des Codes ist fr CAN_START, CAN_STOP
                        ; und CAN_GET_STATUS gemeinsam

                        ; CAN-Task starten
COMMON_START_STOP_STATUS:
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CST_1:                  MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ S E N D
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Senden eines vorher mit CAN_DEF_OBJ definierten Objektes ber
;*     den CAN-Bus.
;*
;* BEGIN
;*    R3 := HIGH(MSG_PTR);
;*    R4 := LOW(MSG_PTR);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_SEND_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R3;
;*       C_ORDER_BUF.PARAM[1] := R4;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_SEND;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     R6/R7   : MSG_PTR            Pointer zu einer Struktur vom Typ
;*
;*
;*     Returnwert in R7 :
;*
;*        C_OK                 Objekt wird gesendet
;*        C_OBJ_ERROR          Das Objekt mit der angegebenen
;*                             Identifikation ist nicht bekannt oder
;*                             das Objekt kann nicht gesendet werden
;*                             (OBJECT_TYP in CAN_DEF_OBJ ist nur auf
;*                             Empfang)
;*        C_BUS_OFF            CAN-Controller ist im Bus-Off Zustand
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/


?CAN?_can_send?HCANAPIF     SEGMENT CODE
                           RSEG    ?CAN?_can_send?HCANAPIF

_can_send:
                        MOV     A, R6
                        MOV     R3, A
                        MOV     A, R7
                        MOV     R4, A
                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CSE_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_SEND_ORDER, 2

                        ; Der Rest des Codes ist fr CAN_WRITE und CAN_SEND
                        ; gemeinsam
                        JMP   COMMON_WRITE_SEND

CSE_1:                  MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ W R I T E
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Mit CAN_SEND wird ein Objekt direkt ber den CAN-Bus gesendet.
;*     Mit CAN_WRITE knnen neue Daten in ein Objekt geschrieben werden,
;*     ohne es sofort zu Senden. Falls dieses Objekt auf Remote-Frames
;*     antworten kann (wird mit CAN_DEF_OBJ festgelegt), werden beim
;*     Eintreffen eines entsprechenden Remote-Frames von einem anderen
;*     Knoten, diese neuen Daten ausgesendet.
;*
;* BEGIN
;*    R3 := HIGH(MSG_PTR);
;*    R4 := LOW(MSG_PTR);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_WRITE_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R3;
;*       C_ORDER_BUF.PARAM[1] := R4;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_WRITE;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     R6/R7   : MSG_PTR         Pointer zu einer Struktur vom Typ
;*
;*
;*     Returnwert in R7 :
;*
;*        C_OK                 Objekt wurde neu beschrieben
;*        C_OBJ_ERROR          Das Objekt mit der angegebenen
;*                             Identifikation ist nicht bekannt oder das
;*                             Objekt kann nicht gesendet werden
;*                             (OBJECT_TYP in CAN_DEF_OBJ ist nur
;*                             auf Empfang)
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/


?CAN?_can_write?HCANAPIF     SEGMENT CODE
                            RSEG    ?CAN?_can_write?HCANAPIF

_can_write:
                        MOV     A, R6
                        MOV     R3, A
                        MOV     A, R7
                        MOV     R4, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CWR_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_WRITE_ORDER, 2

                        ; Der Rest des Codes ist fr CAN_WRITE und CAN_SEND
                        ; gemeinsam

                        ; CAN-Task starten
COMMON_WRITE_SEND:
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait

                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CWR_1:                  MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ R E C E I V E
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Empfangen aller normalen Objekte (alle die nicht mit
;*     CAN_BIND_OBJ einem bestimmten Task zugeordnet sind). Die
;*     empfangenen Meldungen werden in einer Mailbox
;*     zwischengespeichert. Es knnen maximal 8 Objekte zwischengespeichert
;*     werden. Falls der Applikationstask die Objekte nicht aus
;*     der Mailbox liest gehen alle weiteren Objekte verloren
;*     (sie werden dem Applikationstask nicht bermittelt).
;*
;* BEGIN
;*    R3 := TIMEOUT;
;*    R4 := HIGH(BUFFER_PTR);
;*    R5 := LOW(BUFFER_PTR);
;*    PUSH R4;
;*    PUSH R5;
;*    ret = os_wait (K_TMO + K_MBX + 7, R3, BUFFER_PTR (* R4 und R5 *));
;*    POP R5;
;*    POP R4;
;*    IF ret = TMO_EVENT THEN
;*       RETURN C_TIMEOUT;
;*    END;
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_READ_W_IND_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R4;
;*       C_ORDER_BUF.PARAM[1] := R5;
;*       C_ORDER_BUF.PARAM[2] := Wert an der Adresse BUFFER_PTR+1 (* R4,R5 *)
;*       (* Der CAN-Task sendet ber die Mailbox den Index des empfangenen *)
;*       (* Objektes, dieser Index wird an die Adresse BUFFER_PTR          *)
;*       (* abgespeichert -> BUFFER_PTR als Argument bei RTX_WAIT          *)
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END;
;* END CAN_RECEIVE;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     R7      : TIMEOUT           Timeout falls in einer bestimmten Zeit
;*                                 kein Objekt empfangen wurde. Definition
;*                                 analog RTX-51;
;*                                 0        :  Kein Timeout, falls kein
;*                                             Objekt vorhanden ist, luft
;*                                             der Applikations-Task weiter
;*                                             ohne zu warten
;*                                 1..254   :  Anzahl RTX-51 Systemticks
;*                                             die der Applikations-Task
;*                                             auf ein Objekt warten soll
;*                                 255      :  Warten bis ein Objekt
;*                                             empfangen wurde
;*                                             (wait forever)
;*
;*     R4/R5   : BUFFER_PTR        Pointer zu einer Struktur von Typ
;*                                 CAN_MESSAGE_STRUCT im externen RAM.
;*                                 Der CAN-Treiber kopiert das empfangene
;*                                 Objekt in diese Variable.
;*
;*
;*     Returnwert in R7 :
;*
;*        C_OK                 Es wurde ein Objekt empfangen
;*        C_TIMEOUT            Es wurde innerhalb der mit TIMEOUT
;*                             angegebenen Zeit kein Objekt empfangen
;*        C_BUS_OFF            CAN-Controller ist im Bus-Off Zustand
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/


?CAN?_can_receive?HCANAPIF        SEGMENT CODE
                                 RSEG    ?CAN?_can_receive?HCANAPIF

_can_receive:
                        MOV     A, R7
                        MOV     R3, A
                        MOV     A, R4
                        PUSH    ACC
                        MOV     A, R5
                        PUSH    ACC
                        MOV     R7, #(K_MBX+K_TMO+7)
                        MOV     B, R3
                        MOV     A, R4
                        MOV     R2, A
                        MOV     A, R5
                        MOV     R3, A
                        MOV     R5, B
                        CALL    _os_wait
                        POP     ACC
                        MOV     R5, A
                        POP     ACC
                        MOV     R4, A

                        ; Test ob Timeout
                        CJNE    R7, #TMO_EVENT, CRE_1
                        MOV     R7, #C_TIMEOUT
                        RET

                        ; Testen ob CAN-Task besetzt
CRE_1:                  CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CRE_2

                        ; Befehle an CAN-Task aufsetzen
                        MOV     DPTR, #C_ORDER_BUF_ORDER
                        MOV     A, #CAN_READ_W_IND_ORDER
                        MOVX    @DPTR, A
                        INC     DPL
                        INC     DPL
                        MOV     A, R4
                        MOVX    @DPTR, A
                        INC     DPL
                        MOV     A, R5
                        MOVX    @DPTR, A

                        MOV     DPH, R4
                        MOV     DPL, R5
                        INC     DPTR      ; Nur Low-Byte nehmen
                        MOVX    A, @DPTR
                        MOV     DPTR, #C_ORDER_BUF_PARAM+2
                        MOVX    @DPTR, A
                        CALL    os_running_task_id
                        MOV     DPTR, #C_ORDER_BUF_ID
                        MOV     A, R7
                        MOVX    @DPTR, A

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CRE_2:                  MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ B I N D _ O B J
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Bindet ein bestimmtes (mit CAN_DEF_OBJ) definiertes Objekt an
;*     einen bestimmten Task. Beim Empfang dieses Objekts wird dieser
;*     Task gestartet (er muss mit CAN_WAIT auf dieses Objekt warten).
;*     Diese Funktion implementiert einen besonders schnellen Empfang
;*     eines bestimmten, besonders wichtigen Objektes. Ein Task kann mit
;*     CAN_BIND_OBJ an mehrere Objekte gekoppelt werden (mehrfacher
;*     Aufruf von CAN_BIND_OBJ). Beim Empfang eines dieser Objekte wird
;*     der Task gestartet (wenn er mit CAN_WAIT wartet).
;*
;* BEGIN
;*    R3 := HIGH(IDENTIFIER);
;*    R4 := LOW(IDENTIFIER);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_BIND_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R3;
;*       C_ORDER_BUF.PARAM[1] := R4;
;*       C_ORDER_BUF.PARAM[2] := os_running_task_id ();
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_BIND_OBJ;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     R6/R7:   IDENTIFIER        Identifikation des Objekts das fest an
;*                                den aufrufenden Task gebunden werden soll
;*
;*  Returnwert in R7 :
;*
;*     C_OK                 Das Objekt IDENTIFIER wurde an den Task
;*                          gebunden
;*     C_OBJ_ERROR          Das Objekt mit der angegebenen Identifikation
;*                          ist nicht bekannt oder das Objekt kann nicht
;*                          empfangen werden
;*     C_MEM_FULL           Es wurden bereits acht CAN_BIND_OBJ
;*                          durchgefhrt (mit CAN_UNBIND_OBJ kann wieder
;*                          eine Bindung frei gemacht werden)
;*     C_OBJ_REBIND         Warnung : Das Objekt mit dem angegebenen
;*                          Identifier war bereits an einen Task gebunden.
;*                          Die alte Verbindung wurde gelst und die neue
;*                          aufgebaut.
;*
;*---------------------------------------------------------------------*/


?CAN?_can_bind_obj?HCANAPIF    SEGMENT CODE
                              RSEG    ?CAN?_can_bind_obj?HCANAPIF

_can_bind_obj:
                        MOV     A, R6
                        MOV     R3, A
                        MOV     A, R7
                        MOV     R4, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CBO_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_BIND_OBJ_ORDER, 2
                        MOV     DPTR, #C_ORDER_BUF_ID
                        MOVX    A, @DPTR
                        MOV     DPTR, #C_ORDER_BUF_PARAM+2
                        MOVX    @DPTR, A

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CBO_1:                  MOV     R7, #C_CAN_FAILURE
                        RET



$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ U N B I N D _ O B J
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Lst eine mit CAN_BIND_OBJ aufgebaute Verbindung zwischen
;*     dem Task und dem Objekt IDENTIFIER. Ab sofort kann dieses
;*     Objekt wieder mit CAN_RECEIVE empfangen werden.
;*
;* BEGIN
;*    R3 := HIGH(IDENTIFIER);
;*    R4 := LOW(IDENTIFIER);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_UNBIND_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R3;
;*       C_ORDER_BUF.PARAM[1] := R4;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_UNBIND_OBJ;
;*
;*---------------------------------------------------------------------*
;*  Parameter (abgespeichert ab ?CAN_UNBIND_OBJ?BYTE) :
;*
;*     R6/R7        IDENTIFIER   Identifikation des Objekts
;*
;*
;*  Returnwert in R7 :
;*
;*     C_OK                 Das Objekt IDENTIFIER wurde vom Task gelst
;*     C_OBJ_ERROR          Das Objekt IDENTIFIER existiert nicht (es
;*                          wurde nicht mit CAN_DEF_OBJ definiert oder
;*                          es wurde nie mit CAN_BIND_OBJ an den Task
;*                          gebunden)
;*
;*---------------------------------------------------------------------*/


?CAN?_can_unbind_obj?HCANAPIF    SEGMENT CODE
                                RSEG    ?CAN?_can_unbind_obj?HCANAPIF

_can_unbind_obj:
                        MOV     A, R6
                        MOV     R3, A
                        MOV     A, R7
                        MOV     R4, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CUO_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_UNBIND_OBJ_ORDER, 2

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CUO_1:                  MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ W A I T
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Diese Funktion ist nur im Zusammenhang mit CAN_BIND_OBJ sinnvoll.
;*     Der Task wartet auf den Empfang eines der mit CAN_BIND_OBJ an
;*     diesen Task gebundenen Objekte. Nach dem Empfang wird das
;*     entsprechende Objekt in die durch BUFFER_PTR bezeichnete
;*     Variable kopiert und der Task gestartet.
;*
;* BEGIN
;*    R3 := TIMEOUT;
;*    R4 := HIGH(BUFFER_PTR);
;*    R5 := LOW(BUFFER_PTR);
;*    PUSH R4;
;*    PUSH R5;
;*    PUSH R3;
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_ACTIVATE_WRITE_ORDER;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       C_LEAVE_DRIVER;
;*       RETURN;
;*    ELSE
;*       POP R3;
;*       POP R5;
;*       POP R4;
;*       RETURN C_CAN_FAILURE;
;*    END;
;*    POP R3;
;*    RTX_WAIT (K_TMO + K_SIG, R3, 0);
;*    POP R5;
;*    POP R4;
;*    IF RTXRETURN = TMO_EVENT THEN
;*       RETURN C_TIMEOUT;
;*    END;
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_READ_W_TID_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R4;
;*       C_ORDER_BUF.PARAM[1] := R5;
;*       C_ORDER_BUF.PARAM[2] := os_running_task_id;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END;
;* END CAN_WAIT;
;*
;*---------------------------------------------------------------------*
;*  Parameter (abgespeichert ab ?CAN_WAIT?BYTE) :
;*
;*     R7      : TIMEOUT           Timeout falls in einer bestimmten Zeit
;*                                 kein Objekt empfangen wurde. Definition
;*                                 analog RTX-51;
;*                                 0        :  Kein Timeout, falls kein
;*                                             Objekt vorhanden ist, luft
;*                                             der Applikations-Task weiter
;*                                             ohne zu warten
;*                                 1..254   :  Anzahl RTX-51 Systemticks
;*                                             die der Applikations-Task
;*                                             auf ein Objekt warten soll
;*                                 255      :  Warten bis ein Objekt
;*                                             empfangen wurde
;*                                             (wait forever)
;*
;*     R4/R5   : HIGH(BUFFER_PTR)  Pointer zu einer Struktur von Typ
;*                                 CAN_MESSAGE_STRUCT im externen RAM.
;*                                 Der CAN-Treiber kopiert das empfangene
;*                                 Objekt in diese Variable.
;*
;*
;*     Returnwert in R7 :
;*
;*        C_OK                 Es wurde ein Objekt empfangen
;*        C_TIMEOUT            Es wurde innerhalb der mit TIMEOUT
;*                             angegebenen Zeit kein Objekt empfangen
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/


?CAN?_can_wait?HCANAPIF       SEGMENT CODE
                             RSEG    ?CAN?_can_wait?HCANAPIF

_can_wait:
                        MOV     A, R7
                        MOV     R3, A
                        MOV     A, R4
                        PUSH    ACC
                        MOV     A, R5
                        PUSH    ACC
			MOV	A, R3
			PUSH	ACC

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CWA_3

                        ; Befehle an CAN-Task aufsetzen
                        MOV     DPTR, #C_ORDER_BUF_ORDER
                        MOV     A, #CAN_ACTIVATE_WAIT_ORDER
                        MOVX    @DPTR, A
                        CALL    os_running_task_id
                        MOV     A, R7
                        MOV     DPTR, #C_ORDER_BUF_ID
                        MOVX    @DPTR, A
                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        CALL    C_LEAVE_DRIVER
                        JMP     CWA_4

CWA_3:                  POP     ACC
                        POP     ACC
                        POP     ACC
                        MOV     R7, #C_CAN_FAILURE
                        RET

CWA_4:                  MOV     R7, #(K_TMO+K_SIG)
                        POP     ACC
                        MOV     R5, A
                        CALL    _os_wait
                        POP     ACC
                        MOV     R5, A
                        POP     ACC
                        MOV     R4, A

                        ; Test ob Timeout
                        CJNE    R7, #TMO_EVENT, CWA_1
                        MOV     R7, #C_TIMEOUT
                        RET

                        ; Testen ob CAN-Task besetzt
CWA_1:                  CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CWA_2

                        ; Befehle an CAN-Task aufsetzen
                        MOV     DPTR, #C_ORDER_BUF_ORDER
                        MOV     A, #CAN_READ_W_TID_ORDER
                        MOVX    @DPTR, A
                        INC     DPTR
                        INC     DPTR
                        MOV     A, R4
                        MOVX    @DPTR, A
                        INC     DPTR
                        MOV     A, R5
                        MOVX    @DPTR, A
                        CALL    os_running_task_id
                        MOV     A, R7
                        MOV     DPTR, #C_ORDER_BUF_ID
                        MOVX    @DPTR, A
                        MOV     DPTR, #C_ORDER_BUF_PARAM+2
                        MOVX    @DPTR, A
                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CWA_2:                  MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ R E Q U E S T
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Sendeanforderung (Remote-Frame) fr ein bestimmtes Objekt
;*     aussenden. Der CAN-Treiber sendet ein Remote-Frame und
;*     benachrichtigt die Applikation nach dem Empfang des
;*     entsprechendenden Objekts auf dem blichen Weg (CAN_RECEIVE
;*     oder CAN_WAIT).
;*
;* BEGIN
;*    R3 := HIGH(IDENTIFIER);
;*    R4 := LOW(IDENTIFIER);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_REQUEST_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R3;
;*       C_ORDER_BUF.PARAM[1] := R4;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_REQUEST;
;*
;*---------------------------------------------------------------------*
;*  Parameter (abgespeichert ab ?CAN_REQUEST?BYTE) :
;*
;*     R6/R7        IDENTIFIER   Identifikation des Kommunikationsobjektes
;*                                entsprechend der CAN-Definition (0 .. 7EFH)
;*
;*
;*  Returnwert in R7 :
;*
;*     C_OK                 Das Remote-Frame wird ausgesendet
;*     C_OBJ_ERROR          Das Objekt IDENTIFIER existiert nicht oder
;*                          es kann kein Remote-Frame aussenden
;*     C_BUS_OFF            CAN-Controller ist im Bus-Off Zustand
;*     C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/


?CAN?_can_request?HCANAPIF    SEGMENT CODE
                             RSEG    ?CAN?_can_request?HCANAPIF

_can_request:
                        MOV     A, R6
                        MOV     R3, A
                        MOV     A, R7
                        MOV     R4, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CRQ_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_REQUEST_ORDER, 2

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CRQ_1:                  MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ R E A D
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Mit dieser Funktion kann jederzeit die gerade aktuelle Version
;*     jedes Objekts gelesen werden (unabhngig davon, ob die Objekte
;*     mit CAN_DEF_OBJ als Empfangs- oder Sende-Objekte konfiguriert
;*     wurden). Diese Funktion ist kein Ersatz fr CAN_RECEIVE, sondern
;*     ist vor allem whrend der Testphase des Applikationstask ntzlich.
;*
;* VAR
;*    IND : BYTE;
;* BEGIN
;*    R3 := HIGH(IDENTIFIER);
;*    R4 := LOW(IDENTIFIER)
;*    R5 := HIGH(BUFFER_PTR);
;*    R6 := LOW(BUFFER_PTR);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_READ_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R5;
;*       C_ORDER_BUF.PARAM[1] := R6;
;*       C_ORDER_BUF.PARAM[2] := R3;
;*       C_ORDER_BUF.PARAM[3] := R4;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END;
;* END CAN_READ;
;*
;*---------------------------------------------------------------------*
;*  Parameter (abgespeichert ab ?CAN_READ?BYTE) :
;*
;*     R6      HIGH(IDENTIFIER)  Identifikation des Kommunikationsobjektes
;*     R7      LOW(IDENTIFIER)   entsprechend der CAN-Definition (0 .. 7EFH)
;*     R4      HIGH(BUFFER_PTR)  Pointer zu einer Struktur von Typ
;*     R5      LOW(BUFFER_PTR)   CAN_MESSAGE_STRUCT im externen RAM.
;*                               Der CAN-Treiber kopiert das Objekt in
;*                               diese Variable.
;*
;*
;*  Returnwert in R7 :
;*
;*     C_OK                 Objekt IDENTIFIER gelesen
;*     C_OBJ_ERROR          Objekt IDENTIFIER existiert nicht
;*
;*---------------------------------------------------------------------*/


?CAN?_can_read?HCANAPIF    SEGMENT CODE
                          RSEG    ?CAN?_can_read?HCANAPIF

_can_read:
                        MOV   B, R4
                        MOV   A, R6
                        MOV   R3, A
                        MOV   A, R7
                        MOV   R4, A
                        MOV   A, R5
                        MOV   R6, A
                        MOV   R5, B

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CRD_1

                        ; Befehle an CAN-Task aufsetzen
                        MOV     DPTR, #C_ORDER_BUF_ORDER
                        MOV     A, #CAN_READ_ORDER
                        MOVX    @DPTR, A
                        INC     DPTR
                        INC     DPTR
                        MOV     A, R5
                        MOVX    @DPTR, A
                        INC     DPTR
                        MOV     A, R6
                        MOVX    @DPTR, A
                        INC     DPTR
                        MOV     A, R3
                        MOVX    @DPTR, A
                        INC     DPTR
                        MOV     A, R4
                        MOVX    @DPTR, A
                        CALL    os_running_task_id
                        MOV     DPTR, #C_ORDER_BUF_ID
                        MOV     A, R7
                        MOVX    @DPTR, A

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CRD_1:                  MOV     R7, #C_CAN_FAILURE
                        RET




;=======================================================================
;
;     ENDE DES INCLUDE FILE CANAP_2.INC
;
;=======================================================================


